/**
Beschreibung der Klasse Knoten

- author: Klaus Reinold
- version: 1.0
*/
class Knoten
{
    /** Verwaltung des nachfolgenden Knoten in der Warteschlange. */
    private var nachfolger: Knoten?

    /** Verwaltung der Daten */
    private var zahl: Int

    /**
	Konstruktor des Knoten
	- parameters:
		- i: Zahl
 		- kNeu: neuer Nachfolger
    */
    init(i: Int, kNeu: Knoten?)
    {
        zahl = i
        nachfolger = kNeu
    }

    /**
	Gibt Information über das Datenelement aus.
    */
    func InformationAusgeben()
    {
        print(zahl)
        if nachfolger != nil
        {
            nachfolger!.InformationAusgeben()
        }
    }


    /**
	Fügt ein Datenelement sortiert in die Liste ein
	- parameters:
		- zahlNeu: neues Datenelement
	- returns: Weitergabe des künftigen Nachfolgers
     */
    func SortiertEinfügen(zahlNeu: Int)
    {
        if zahlNeu > zahl
        {
            return Knoten(i: zahlNeu, kNeu: self)
            
        }
        else
        {
            if nachfolger != nil
            {
                nachfolger = nachfolger!.SortiertEinfügen(zahlNeu: zahlNeu);
            }
            else
            {
                nachfolger = Knoten(i: zahlNeu, kNeu: nil)
            }
            return self
        }
    }
}

/**
Beschreibung der Liste

- author: Klaus Reinold
- version: 1.0
 */
class Liste
{
    /** erster Knoten der Liste */
    private var anfang: Knoten?

    /**
	Konstruktor der Liste
    */
    init()
    {
        anfang = nil
    }


    /**
	Fügt ein neues Datenelement am Anfang der Liste ein.
	- parameters:
		- zahlNeu: neues Datenelement
    */
    func VorneEinfügen(zahlNeu: Int)
    {
        nachfolger = Knoten(nachfolger,zahlNeu)
    }

    /**
	Gibt Information über die Liste aus.
    */
    func InformationAusgeben()
    {
        if anfang != nil
        {
            anfang!.InformationAusgeben()
        }
    }

 
    /**
	Fügt ein neues Datenelement sortiert in die Liste ein.
	- parameters:
		- dNeu: neues Datenelement
    - returns: (neuen) Nachfolgerknoten
    */
    func SortiertEinfügen(zahlNeu: Int)
    {
        if anfang != nil
        {
            anfang = anfang!.SortiertEinfügen(zahlNeu: zahlNeu)
        }
        else
        {
            VorneEinfügen(zahlNeu: zahlNeu)
        }
    }
}

/**
Klasse zur Verwaltung der Lottozahlen

- author: Klaus Reinold
- version: 1.0
*/
class Lotto
{
    private var l: Liste

    /**
	Konstruktor der Klasse Lotto
	erzeugt eine leere Liste
    */
    init()
    {
        l = Liste()
    }
    
    /**
	Einfügen einer neuen Zahl
	- parameters:
		- i: einzufügende int-Zahl
    */
    func Einfügen(i: Int)
    {
        l.SortiertEinfügen(zahlNeu: i)
    }
    
    /**
	Ausgabe aller Zahlen über die Konsole
    */
    func Ausgeben()
    {
        l.InformationAusgeben()
    }
}

